Index: Thuban/UI/viewport.py
===================================================================
--- Thuban/UI/viewport.py	(révision 2708)
+++ Thuban/UI/viewport.py	(copie de travail)
@@ -963,48 +963,58 @@
             label_layer.RemoveLabel(shape_index)
             return True
         elif layer is not None and text:
-            proj = self.map.projection
-            if proj is not None:
-                map_proj = proj
-            else:
-                map_proj = None
-            proj = layer.projection
-            if proj is not None:
-                layer_proj = proj
-            else:
-                layer_proj = None
-
-            shapetype = layer.ShapeType()
-            if shapetype == SHAPETYPE_POLYGON:
-                shapefile = layer.ShapeStore().Shapefile().cobject()
-                x, y = shape_centroid(shapefile, shape_index,
-                                      map_proj, layer_proj, 1, 1, 0, 0)
-                if map_proj is not None:
-                    x, y = map_proj.Inverse(x, y)
-            else:
-                shape = layer.Shape(shape_index)
-                if shapetype == SHAPETYPE_POINT:
-                    x, y = shape.Points()[0][0]
-                else:
-                    # assume SHAPETYPE_ARC
-                    points = shape.Points()[0]
-                    x, y = points[len(points) / 2]
-                if layer_proj is not None:
-                    x, y = layer_proj.Inverse(x, y)
-            if shapetype == SHAPETYPE_POINT:
-                halign = ALIGN_LEFT
-                valign = ALIGN_CENTER
-            elif shapetype == SHAPETYPE_POLYGON:
-                halign = ALIGN_CENTER
-                valign = ALIGN_CENTER
-            elif shapetype == SHAPETYPE_ARC:
-                halign = ALIGN_LEFT
-                valign = ALIGN_CENTER
+            (x, y, halign, valign)  = self.GetLabelPosFromShape(layer, \
+                                                             shape_index)
             label_layer.AddLabel(x, y, text,
                                  halign = halign, valign = valign)
             return True
         return False
 
+    def GetLabelPosFromShape(self, layer, shape_index):
+        '''
+        Return the label position parameters (x, y, halign, valign) from the
+        shape object
+        '''
+        proj = self.map.projection
+        if proj is not None:
+            map_proj = proj
+        else:
+            map_proj = None
+        proj = layer.projection
+        if proj is not None:
+            layer_proj = proj
+        else:
+            layer_proj = None
+
+        shapetype = layer.ShapeType()
+        if shapetype == SHAPETYPE_POLYGON:
+            shapefile = layer.ShapeStore().Shapefile().cobject()
+            x, y = shape_centroid(shapefile, shape_index,
+                                  map_proj, layer_proj, 1, 1, 0, 0)
+            if map_proj is not None:
+                x, y = map_proj.Inverse(x, y)
+        else:
+            shape = layer.Shape(shape_index)
+            if shapetype == SHAPETYPE_POINT:
+                x, y = shape.Points()[0][0]
+            else:
+                # assume SHAPETYPE_ARC
+                points = shape.Points()[0]
+                x, y = points[len(points) / 2]
+            if layer_proj is not None:
+                x, y = layer_proj.Inverse(x, y)
+        if shapetype == SHAPETYPE_POINT:
+            halign = ALIGN_LEFT
+            valign = ALIGN_CENTER
+        elif shapetype == SHAPETYPE_POLYGON:
+            halign = ALIGN_CENTER
+            valign = ALIGN_CENTER
+        elif shapetype == SHAPETYPE_ARC:
+            halign = ALIGN_LEFT
+            valign = ALIGN_CENTER
+        
+        return (x, y, halign, valign)
+
 def output_transform(canvas_scale, canvas_offset, canvas_size, device_extend):
     """Calculate dimensions to transform canvas content to output device."""
     width, height = device_extend
